#include <allegro.h>
#include <time.h>

void init();
void deinit();
void drawAndFlip(BITMAP*, int);
int convertMaze(BITMAP*, BITMAP*, BITMAP*, BITMAP*, BITMAP*, BITMAP*);
BITMAP* createPonyBuffer(BITMAP*, BITMAP*, BITMAP*, BITMAP*, BITMAP*, BITMAP*);


int main() 
{	
	init();
	BITMAP *buffer = create_bitmap(640, 480);
	clear_bitmap(buffer);
	BITMAP* twiImg = load_bitmap("twi.bmp", NULL);
	
    BITMAP* m1     = load_bitmap("m01.bmp", NULL);
    BITMAP* t0     = load_bitmap("0.bmp", NULL);
	BITMAP* t1     = load_bitmap("1.bmp", NULL);
	BITMAP* t2     = load_bitmap("2.bmp", NULL);
    BITMAP* t3     = load_bitmap("3.bmp", NULL);
    
 	BITMAP* ts     = load_bitmap("ts.bmp", NULL);
    BITMAP* rt     = load_bitmap("rt.bmp", NULL);
    BITMAP* pp     = load_bitmap("pp.bmp", NULL);
	BITMAP* aj     = load_bitmap("aj.bmp", NULL);
	BITMAP* rd     = load_bitmap("rd.bmp", NULL);
    BITMAP* fs     = load_bitmap("fs.bmp", NULL);
 
 
 
    BITMAP* twiAnimation[12];
 
 
 	for(int i = 0; i < 12; i++)
	{
            twiAnimation[i] = create_bitmap(64,64);
            clear_bitmap(twiAnimation[i]);
            blit(twiImg, twiAnimation[i],(int) 64*(i%3),(int) 64*(i/3), 0, 0,64, 64);
    }
    destroy_bitmap(twiImg);
	
	BITMAP* maze01Map = create_bitmap(2624, 2624);
	int entranceInt;
    entranceInt    = convertMaze(m1,maze01Map, t0,t1,t2,t3);
    BITMAP* ponyBuffer = createPonyBuffer(m1,aj,fs,pp,rd,rt);
	bool update = true;
	int walkingFrame = 0;
	int lastDir = 9;
	bool lkeyJustPressed = true;
	bool rkeyJustPressed = true;
	bool ukeyJustPressed = true;
	bool dkeyJustPressed = true;
	int lTicker,rTicker,uTicker,dTicker;
	int mx = (320 - 32) - ((entranceInt % 41)*64) ;
	int my = (240 - 32)- ((entranceInt / 41)*64);
	int speed = 6;
	int elements[5] = {0,0,0,0,0};//aj[0],fs[1],pp[2],rd[3],rt[4]
	time_t start,current;
    int timeLimit = 6;
    int timeLeft = 0;
	time(&start);
	
	int menuSelection = 0;
	bool exitGame = false;
	int mane6Recovered = 0;
	

          menuStart:
/*----------------------------------------------------------------------------*/      


     
                  textprintf_centre_ex(buffer, font, 320, 20, 0xFFFFFF,-1, "Discord's Maze Game - 10 Seconds Flat Edition!");
                  textprintf_centre_ex(buffer, font, 320, 40, 0xFFFFFF,-1, "By DrTyphoid");
                  textprintf_centre_ex(buffer, font, 320, 60, 0xFFFFFF,-1, "In case you didn't know, I don't own MLP.");
                  
                  textprintf_centre_ex(buffer, font, 320, 160, 0xFFFFFF,-1, "DA RULES:");
                  
                  
                  textprintf_ex(buffer, font, 20 , 180, 0xFFFFFF,-1, "Help Twilight Sparkle rescue her friends trapped in Discord's maze!");
                  textprintf_ex(buffer, font, 20, 200, 0xFFFFFF,-1, "Use the arrow keys to navigate. Press ESC at any time to end the game.");
                  textprintf_ex(buffer, font, 20, 220, 0xFFFFFF,-1, "Find them, and the exit before time runs out.");

                  masked_blit(aj, buffer,0,0, 260-32,300-32,64,64);                
                  masked_blit(fs, buffer,0,0, 290-32,300-32,64,64);
                  masked_blit(pp, buffer,0,0, 320-32,300-32,64,64);
                  masked_blit(rd, buffer,0,0, 350-32,300-32,64,64);
                  masked_blit(rt, buffer,0,0, 380-32,300-32,64,64);
                  masked_blit(ts, buffer,0,0, 320-32,370-32,64,64);     
                                 
                  
                  textprintf_centre_ex(buffer, font, 320, 420, 0xFFFFFF,-1, "PRESS ANY KEY TO START");
                  
                  
                  drawAndFlip(buffer,10);

                  readkey();
          
          
          
          
          
          
          
       gameStart:   
/*----------------------------------------------------------------------------*/  
    while (!exitGame) 
    {                  
       time(&current);
       timeLeft = (timeLimit*60) - (int)(difftime (current,start));
       if(timeLeft <= 0)
        goto gameEnd;
       update = true;
       
             if(keypressed())
             {
                 if(key[KEY_LEFT])
                 { 
                  if(lkeyJustPressed)
                    {lTicker = 0; lkeyJustPressed = false;}
                  if(lTicker >= 0 && lTicker  < 10)
                    walkingFrame = 1;
                  if(lTicker >= 10 && lTicker  < 20)
                    walkingFrame = 0;
                  if(lTicker >= 20 && lTicker < 30)
                    walkingFrame = 2;
                  if(lTicker >= 30 && lTicker < 40)
                    walkingFrame = 0;
                  if(lTicker > 40)
                    lTicker = 0;
                    
                    lTicker+=2;
    
                    if(  getpixel(maze01Map, 320-32 + 11 -mx , 240  - my) != 0x68976F)
                     mx+= speed;

                  lastDir = 0;
                  update = true;
                  goto label;
                 }
                 
                 if(key[KEY_RIGHT])
                 {
                  if(rkeyJustPressed)
                   {rTicker = 0; rkeyJustPressed= false;}
                  if(rTicker >= 0 && rTicker  < 10)
                    walkingFrame = 4;
                  if(rTicker >= 10 && rTicker  < 20)
                    walkingFrame = 3;
                  if(rTicker >= 20 && rTicker < 30)
                    walkingFrame = 5;
                  if(rTicker >= 30 && rTicker < 40)
                    walkingFrame = 3;
                  if(rTicker > 40)
                    rTicker = 0;
            
                  rTicker+=2;
                  if( getpixel(maze01Map, 320-32 + 53-mx , 240  -my) != 0x68976F)
                     mx-= speed;
                  
                  lastDir = 3;
                  update = true;
                  goto label;
                 }
                 
                 if(key[KEY_UP])
                 {
                  if(ukeyJustPressed)
                    {uTicker = 0; ukeyJustPressed= false;}
                  
                  if(uTicker >= 00 && uTicker  < 10)
                    walkingFrame = 7;
                  if(uTicker >= 10 && uTicker  < 20)
                    walkingFrame = 6;
                  if(uTicker >= 20 && uTicker < 30)
                    walkingFrame = 8;
                  if(uTicker >= 30 && uTicker < 40)
                    walkingFrame = 6;
                  if(uTicker > 40)
                    uTicker = 0;
                  
                  uTicker+=2;
                  if( getpixel(maze01Map,320 -mx, 240-32 + 6-my) != 0x68976F )
                     my+= speed;
                  
                  lastDir = 6;
                  update = true;
                  goto label;
                 }
                 
                 if(key[KEY_DOWN])
                 {
                  if(dkeyJustPressed)
                    {dTicker = 0; dkeyJustPressed= false;}
                  if(dTicker >= 0 && dTicker  < 10)
                    walkingFrame = 10;
                  if(dTicker >= 10 && dTicker  < 20)
                    walkingFrame = 9;
                  if(dTicker >= 20 && dTicker < 30)
                    walkingFrame = 11;
                  if(dTicker >= 30 && dTicker < 40)
                    walkingFrame = 9;
                  if(dTicker > 40)
                    dTicker = 0;
                  
                  dTicker+=2;
                  if(getpixel(maze01Map, 320 -mx,240-32 + 63-my) != 0x68976F  )
                     my-= speed;
                  
                  lastDir = 9;
                  update = true;
                  goto label;
                 }
                 
                 label:
                 if(key[KEY_ESC])
                 {
                                 exitGame = true;
                                 goto exitGameLabel;
                                 
                 }
                 
                 
             }
              else
             {
                  lkeyJustPressed = true;
                  rkeyJustPressed = true;
                  ukeyJustPressed = true;
                  dkeyJustPressed = true;
                  lTicker = 0;
                  rTicker = 0;
                  dTicker = 0;
                  uTicker = 0;
                  walkingFrame = lastDir;
             }
             
             
             if( getpixel(maze01Map, 320-mx,240-my) == 0x767950)
             { goto gameEnd; }
             if( getpixel(ponyBuffer, 320-mx,240-my) == 0xffc06c)//aj
             { 
                 elements[0] = 1; 
                 blit(t2, ponyBuffer,0,0, 64*((320-mx)/64),64*((240-my)/64),64,64);
             }
             if( getpixel(ponyBuffer, 320-mx,240-my) == 0xfff797)//fs
             { 
                 elements[1] = 1; 
                 blit(t2, ponyBuffer,0,0, 64*((320+-mx)/64),64*((240-my)/64),64,64); 
             }
             if( getpixel(ponyBuffer, 320-mx,240-my) == 0xebbbcf)//pp
             { 
                 elements[2] = 1; 
                 blit(t2, ponyBuffer,0,0, 64*((320-mx)/64),64*((240-my)/64),64,64); 
             }
             if( getpixel(ponyBuffer, 320-mx,240-my) == 0x97d7ff)//rd
             { 
                 elements[3] = 1; 
                 blit(t2, ponyBuffer,0,0, 64*((320-mx)/64),64*((240-my)/64),64,64); 
             }
             if( getpixel(ponyBuffer, 320-mx,240-my) == 0xedf1f4)//rt
             { 
                 elements[4] = 1; 
                 blit(t2, ponyBuffer,0,0, 64*((320-mx)/64),64*((240-my)/64),64,64);
             }


             if(update)
             {
                 clear_to_color(buffer, 0x4a6c4f);
                 //makecol(104,151,111)
                 draw_sprite(buffer, maze01Map, mx, my);
                 draw_sprite(buffer, ponyBuffer, mx, my);
                 draw_sprite(buffer, twiAnimation[walkingFrame], 320-32, 240-32);
                 
                 line(buffer, 260,100,380,100,0xFFFFFF);
                 circlefill(buffer, 260,100,5, 0xFF0000);
                 circlefill(buffer, 290,100,5, 0xff9200);
                 circlefill(buffer, 320,100,5, 0xfff000);
                 circlefill(buffer, 350,100,5, 0x00FF00);
                 circlefill(buffer, 380,100,5, 0x0000FF);
                 
                 if(elements[0] == 1)
                  masked_blit(aj, buffer,0,0, 260-32,100-32,64,64);
                 if(elements[1] == 1)
                  masked_blit(fs, buffer,0,0, 290-32,100-32,64,64);
                 if(elements[2] == 1)
                  masked_blit(pp, buffer,0,0, 320-32,100-32,64,64);
                 if(elements[3] == 1)
                  masked_blit(rd, buffer,0,0, 350-32,100-32,64,64);
                 if(elements[4] == 1)
                  masked_blit(rt, buffer,0,0, 380-32,100-32,64,64);
                 
                 textprintf_centre_ex(buffer, font, 320, 20, 0xFF0000,-1, "%i:%02d",timeLeft/60,timeLeft%60);

                 //textprintf_ex(buffer, font, 100, 120, makecol(255,255,255),-1, "aj- %i, fs- %i pp- %i, rd- %i rt- %i",elements[0],elements[1],elements[2],elements[3],elements[4]);
                 //textprintf_ex(buffer, font, 100, 120, makecol(255,255,255),-1, "x- %i, y- %i",64*((320+32-mx)/64),64*((240+32-my)/64));
                 //circle(buffer, 320-mx,240-my,5, 0xFF0000);

                  

                 drawAndFlip(buffer,10);
                 update = false;
             }     
             
    }
    
	gameEnd:
/*----------------------------------------------------------------------------*/      

for(int i = 0; i < 4; i++)
{
 if(elements[i] == 1)
  mane6Recovered++;
}

clear_bitmap(buffer);
drawAndFlip(buffer,10);

if(timeLeft > 0 && mane6Recovered == 5)
textprintf_centre_ex(buffer, font, 320, 20, 0xFFFFFF,-1, "Congradulations! You completed the maze with all your friends!");
if(timeLeft == 0 || mane6Recovered < 5)
textprintf_centre_ex(buffer, font, 320, 20, 0xFFFFFF,-1, "Game over!");


textprintf_centre_ex(buffer, font, 320, 40, 0xFFFFFF,-1, "SCORE:");

textprintf_ex(buffer, font, 100 , 180, 0xFFFFFF,-1, "Time left: %i sec. X 1,000 = %i", timeLeft, timeLeft * 1000);
textprintf_ex(buffer, font, 100 , 200, 0xFFFFFF,-1, "Friends recovered: %i X 4,000 = %i", mane6Recovered,  mane6Recovered * 4000);
textprintf_ex(buffer, font, 100 , 220, 0xFFFFFF,-1, "=");
textprintf_ex(buffer, font, 100 , 240, 0xFFFFFF,-1, "* %i *",(timeLeft * 1000) + ( mane6Recovered * 4000));

textprintf_centre_ex(buffer, font, 320, 400, 0xFFFFFF,-1, "Thanks for playing!");


drawAndFlip(buffer,10);
rest(1000);
clear_keybuf();

readkey();


exitGameLabel:
   
        
	destroy_bitmap(buffer);
	deinit();
	return 0;
}
END_OF_MAIN();
















void init()
{
	allegro_init();
	install_timer();
	install_keyboard();
	install_mouse();
	
	set_color_depth(32);
	set_gfx_mode(GFX_AUTODETECT_WINDOWED, 640, 480, 0, 0);

}

void deinit() {
	clear_keybuf();
	/* add other deinitializations here */
}

void drawAndFlip(BITMAP* buff,int wait)
{    
                 blit(buff, screen, 0, 0, 0, 0, 640, 480);
                 rest(wait);
                 clear_bitmap(buff);
                 rest(wait);
}

int convertMaze(BITMAP* m, BITMAP* mi, BITMAP* tl0, BITMAP* tl1, BITMAP* tl2, BITMAP* tl3)
{
        int strt;
    	for(int i = 0; i < 1681; i++)
    	{
                
                if(getpixel(m, 13*(i%41), 13*(i/41)) == 0xFFFFFF)
                {
                blit(tl2,mi, 0,0, (int) 64*(i%41),(int) 64*(i/41), 64,64);
                }
                if(getpixel(m, 13*(i%41) , 13*(i/41)) == 0x97d7ff || getpixel(m, 13*(i%41) , 13*(i/41)) == 0xffc06c
                || getpixel(m, 13*(i%41) , 13*(i/41)) == 0xa6b1b7 || getpixel(m, 13*(i%41) , 13*(i/41)) == 0xebbbcf
                || getpixel(m, 13*(i%41) , 13*(i/41)) == 0xfff797 || getpixel(m, 13*(i%41) , 13*(i/41)) == 0x0000FF)
                {
                 blit(tl2,mi, 0,0, (int) 64*(i%41),(int) 64*(i/41), 64,64);
                }
                
                if(getpixel(m, 13*(i%41) , 13*(i/41)) == 0x000000)
                {
                if(getpixel(m, 13*(i%41) , 13*((i + 41)/41)) == 0xFFFFFF || getpixel(m, 13*(i%41) , 13*((i + 41)/41)) == 0x97d7ff 
                || getpixel(m, 13*(i%41) , 13*((i + 41)/41)) == 0xffc06c || getpixel(m, 13*(i%41) , 13*((i + 41)/41)) == 0xa6b1b7 
                || getpixel(m, 13*(i%41) , 13*((i + 41)/41)) == 0xebbbcf || getpixel(m, 13*(i%41) , 13*((i + 41)/41)) == 0xfff797 
                || getpixel(m, 13*(i%41) , 13*((i + 41)/41)) == 0x0000FF)
                blit(tl1,mi, 0,0, (int) 64*(i%41),(int) 64*(i/41), 64,64);
                else 
                 blit(tl0,mi, 0,0, (int) 64*(i%41),(int) 64*(i/41), 64,64);
                }
                
                if(getpixel(m, 13*(i%41) , 13*(i/41)) == 0x0000FF)
                {
                 strt = i;
                }
                if(getpixel(m, 13*(i%41) , 13*(i/41)) == 0xFF0000)
                {
                 if( i/41 == 0)
                  blit(tl3,mi, 0,0, (int) 64*(i%41),(int) 64*(i/41), 64,64);
                 if( i/41 == 41)
                  blit(tl3,mi, 64,0, (int) 64*(i%41),(int) 64*(i/41), 64,64);
                 if( i%41 == 13)
                  blit(tl3,mi, 128,0, (int) 64*(i%41),(int) 64*(i/41), 64,64);
                 if( i%41 == 0)
                  blit(tl3,mi, 192,0, (int) 64*(i%41),(int) 64*(i/41), 64,64);
                }
                

                //textprintf_ex(mi, font, (int) 64*(i%41),(int) 64*(i/41), makecol(255,255,255),-1, "%i",i);

        }
        return strt;
}


BITMAP* createPonyBuffer(BITMAP* m, BITMAP* aj, BITMAP* fs ,BITMAP* pp, BITMAP* rd ,BITMAP* rt)
{
        BITMAP* pBuff = create_bitmap(2624, 2624);
	    clear_to_color(pBuff, makecol(0xff,0,0xff));
    	for(int i = 0; i < 1681; i++)
    	{
                if(getpixel(m, 13*(i%41), 13*(i/41)) == 0xffc06c)   // aj      
                 masked_blit(aj,pBuff, 0,0, (int) 64*(i%41),(int) 64*(i/41), 64,64);  
                if(getpixel(m, 13*(i%41), 13*(i/41)) == 0xa6b1b7)   // rt
                 masked_blit(rt,pBuff, 0,0, (int) 64*(i%41),(int) 64*(i/41), 64,64);
                if(getpixel(m, 13*(i%41), 13*(i/41)) == 0x97d7ff)   //rd
                 masked_blit(rd,pBuff, 0,0, (int) 64*(i%41),(int) 64*(i/41), 64,64);        
                if(getpixel(m, 13*(i%41), 13*(i/41)) == 0xfff797)   //fs
                 masked_blit(fs,pBuff, 0,0, (int) 64*(i%41),(int) 64*(i/41), 64,64);
                if(getpixel(m, 13*(i%41), 13*(i/41)) == 0xebbbcf)   //pp
                 masked_blit(pp,pBuff, 0,0, (int) 64*(i%41),(int) 64*(i/41), 64,64);            
        }
        return pBuff;
}

